## odc 1.5.0

=== docs/requirements.txt ===
sphinx
sphinx-rtd-theme==0.5.2
sphinx-copybutton==0.3.1
sphinx-tabs
breathe
six
sphinx-fortran

=== regressions/CMakeLists.txt ===

list( APPEND regressions_data_files
    odb_387_mdset.odb
    odb_463.odb
    sd_45315-reduced.odb
    sd_45479_source.odb
    sd_45479_compare.odb
)

ecbuild_get_test_multidata( TARGET odc_get_regressions_data
                            #DIRNAME odc/tests
                            NAMES ${regressions_data_files}
                            NOCHECK )

set(regressions_scripts

    ODB-374.sh
    ODB-387-and-388.sh
    ODB-463.sh
    SD-45315.sh
    SD-45479.sh
    ODB-529.sh
)

foreach( _script ${regressions_scripts})
    ecbuild_add_test(
        TYPE script
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${_script}
        ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
        TEST_DEPENDS odc_get_test_data odc_get_regressions_data
    )
endforeach()


# Add a custom target to make these files visible in qtcreator

add_custom_target(
    regressions_file_visibility
    SOURCES ${regressions_scripts}
)

=== tests/CMakeLists.txt ===
### test data files


list( APPEND test_data_files
2000010106-reduced.odb
)

ecbuild_get_test_multidata( TARGET odc_get_test_data
                            #DIRNAME odc/tests
                            NAMES ${test_data_files}
                            NOCHECK )

### list tests

list( APPEND odc_tests
Test_AggregateFunctions
Test_AggregateFunctions2
Test_AggregateFunctions3
Test_AtTableInTheOutput
Test_Bitfields
Test_CREATE_TABLE_and_SELECT_INTO
Test_CommandLineParsing
Test_DispatchingWriter
Test_Distinct
Test_FunctionDateAndTime
Test_FunctionTdiff
Test_FunctionThin
Test_FunctionTypeConversion
Test_FunctionsForAngleConversion
Test_FunctionsForTemperatureConversion
Test_Int16_MissingCodec
Test_IntegerValues
Test_JULIAN_SECONDS
Test_MetaData
Test_MissingValue
Test_OrderBy
Test_SelectDataHandle
Test_SelectStarAt
Test_SelectTwoFiles
Test_Setvbuffer
Test_Star
Test_bitfieldsLength
Test_bitfields_hash_operator
Test_hash_operator_in_where
Test_hash_operator_on_select_list
Test_include
Test_log_error
Test_meta_data_reader_checks_if_file_truncated
Test_operator_ge
Test_rownumber1
Test_selectAggregatedAndNonAggregated
Test_selectAggregatedAndNonAggregated2
Test_selectAggregatedAndNonAggregated3
Test_selectAggregatedAndNonAggregatedNULL
Test_select_constant_value
Test_sqlOutputFormatting
Test_stringInWhere
Test_windSpeedWindDirection
Test_QuestionMarkHandlingWhenSplittingByStringColumn_ODB235

Test_example_select_data_read_results
Test_example_read_data
Test_example_write_data

Test_c_api_example_write_data
)


set( test_environment
  odc_CODES=${PROJECT_SOURCE_DIR}/etc
  odc_HOME=${PROJECT_SOURCE_DIR}
  odc_TEST_DATA_PATH=${CMAKE_CURRENT_BINARY_DIR}
  PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}

  TEST_DHSHOME=${CMAKE_CURRENT_BINARY_DIR}/dhshome/
  TEST_DATA_DIRECTORY=${CMAKE_CURRENT_BINARY_DIR}
  )

### odc tests

set( _prev_test odc_get_test_data  )

foreach( _test ${odc_tests} )
    set( _dependencies ${_prev_test} )
    ecbuild_add_test( TARGET       ${_test}
                      COMMAND      $<TARGET_FILE:odc>
                      ARGS         ${_test}
                      ENVIRONMENT  ${test_environment}
                      LABELS       odc
                      TEST_DEPENDS ${_dependencies})
    set( _prev_test ${_test} )
endforeach()

ecbuild_add_executable( TARGET      test_client_lib_fortran
                        CONDITION   HAVE_FORTRAN AND HAVE_ODB
                        SOURCES     test_client_lib_fortran.f90
                        LIBS        odc_fortran
                        LINKER_LANGUAGE Fortran)

ecbuild_add_executable( TARGET      test_client_lib_cpp
                        CONDITION   HAVE_ODB
                        SOURCES     test_client_lib_cpp.cc
                        LIBS        odccore odctools )

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_subdirectory( core )
add_subdirectory( sql )
add_subdirectory( tools )
add_subdirectory( api )
add_subdirectory( c_api )
add_subdirectory( f_api )

=== tests/f_api/CMakeLists.txt ===

list( APPEND _api_fodc_tests
    general
    read
    encode
)

foreach( _test ${_api_fodc_tests} )
    ecbuild_add_test(
        TARGET       odc_fapi_${_test}
        SOURCES      ${_test}.f90
        ENVIRONMENT  ${test_environment}
        TEST_DEPENDS odc_get_test_data
        CONDITION    HAVE_FORTRAN
        LIBS         fodc )
endforeach()

list( APPEND _api_fodc_example_sources
    odc_header
    odc_encode_custom
    odc_encode_row_major
    odc_ls
)

list( APPEND _api_fodc_example_targets
    odc-fortran-header
    odc-fortran-encode-custom
    odc-fortran-encode-row-major
    odc-fortran-ls
)

list( LENGTH _api_fodc_example_sources _count )
math( EXPR _count "${_count}-1" )

foreach( _i RANGE ${_count} )
    list( GET _api_fodc_example_sources ${_i} _sources )
    list( GET _api_fodc_example_targets ${_i} _target )

    ecbuild_add_executable( TARGET     ${_target}
                            SOURCES    ${_sources}.f90
                            LIBS       fodc
                            CONDITION  HAVE_FORTRAN
                            NOINSTALL )
endforeach()

list( APPEND _fapi_odc_tests_scripts
    usage_examples.sh
)

foreach( _script ${_fapi_odc_tests_scripts} )
    ecbuild_add_test(
        TARGET odc_fapi_${_script}
        TYPE script
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${_script}
        ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
        CONDITION   HAVE_FORTRAN
    )
endforeach()

=== debian/changelog ===
odc (1.5.0-2deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:14:41 +0800

odc (1.5.0-2) unstable; urgency=medium

  * Rebuild to revert FMODDIR to libdir
  * B-D on dh-fortran-mod > 0.31
  * Use fortran-support.mk
  * Add libodc-dev.links with variable substitution

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 31 Dec 2023 13:14:10 +0000

odc (1.5.0-1) unstable; urgency=medium

  * New upstream release
  * g++-13.patch now upstream; removed

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Dec 2023 08:00:53 +0000

odc (1.4.6-6) unstable; urgency=medium

  * Build with dep architecture-is-64-bit. Closes: #1057681
  * Ensure fortran libs are in fortran-abi-flavour directory
  * Bump eckit dep to >= 1.4.6

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 09 Dec 2023 08:35:05 +0000

=== debian/control ===
Source: odc
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 dh-fortran-mod (>= 0.31),
 architecture-is-64-bit,
 ecbuild (>= 3.3.0-3),
 libeckit-dev (>= 1.4.6-1~),
 patchelf
Standards-Version: 4.6.2
Homepage: https://github.com/ecmwf/odc
Vcs-Browser: https://salsa.debian.org:/science-team/odc.git
Vcs-Git: https://salsa.debian.org:/science-team/odc.git -b debian/latest

Package: libodc-0d
Section: libs
Multi-Arch: same
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Observational Database Access library for ECMWF
 ODC is software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++ and Fortran.

Package: odc
Architecture: any
Multi-Arch: foreign
Depends: libodc-0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libodc-dev (= ${binary:Version})
Description: Tools for the Observational Data Processing (ODB) 
 ODC is software developed at ECMWF for encoding and processing o
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++ and Fortran.
 .
 This package provides tools for ODB handling.

Package: libodc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libodc-0d (= ${binary:Version}), odc (= ${binary:Version}), 
  ${misc:Depends}, mpi-default-dev, libeckit-dev, ${fortran:Depends}
Conflicts: libodb-dev
Recommends: pkg-config, ${fortran:Recommends}
Description: Observational Data processing for meteorology
 ODC is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides shared libraries and headers.

## odc 1.5.2

=== debian/changelog ===
odc (1.5.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 Apr 2024 07:16:14 +0100

odc (1.5.1-1) unstable; urgency=medium

  * New upstream release
  * Now recommend pkgconf, not pkg-config

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 16 Mar 2024 06:35:53 +0000

=== debian/control ===
--- 
+++ 
@@ -43,7 +43,7 @@
 Depends: libodc-0d (= ${binary:Version}), odc (= ${binary:Version}), 
   ${misc:Depends}, mpi-default-dev, libeckit-dev, ${fortran:Depends}
 Conflicts: libodb-dev
-Recommends: pkg-config, ${fortran:Recommends}
+Recommends: pkgconf, ${fortran:Recommends}
 Description: Observational Data processing for meteorology
  ODC is a software developed at ECMWF for encoding and processing of
  observational data. It includes a SQL filtering and statistics engine,

## odc 1.6.0

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

########################################################################################################################

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( odc LANGUAGES C CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### sanity checks

### long and double must be 64 bits exactly

# test by c compilation
ecbuild_check_c_source_return(
    "#include <stdio.h>\nint main(){printf(\"%ld\",sizeof(long));return 0;}"
    VAR check_long_final
    OUTPUT __sizeof_long_final
)
ecbuild_check_c_source_return(
    "#include <stdio.h>\nint main(){printf(\"%ld\",sizeof(double));return 0;}"
    VAR check_double_final
    OUTPUT __sizeof_double_final
)

if( NOT check_long_final OR NOT __sizeof_long_final EQUAL "8" )
    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof long [${__sizeof_long_final}] -- long must be 64 bits exactly" )
elseif( NOT check_double_final OR NOT __sizeof_double_final EQUAL "8" )
    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof double [${__sizeof_double_final}] -- double must be 64 bits exactly" )
endif()

# test by cxx compilation
ecbuild_check_cxx_source_return(
    "#include <iostream>\nint main(){ std::cout << sizeof(long);return 0;}"
    VAR cxx_check_long_final
    OUTPUT __cxx_sizeof_long_final
)
ecbuild_check_cxx_source_return(
    "#include <iostream>\nint main(){ std::cout << sizeof(double);return 0;}"
    VAR cxx_check_double_final
    OUTPUT __cxx_sizeof_double_final
)

if( NOT cxx_check_long_final OR NOT __cxx_sizeof_long_final EQUAL "8" )
    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof long [${__cxx_sizeof_long_final}] -- long must be 64 bits exactly" )
elseif( NOT cxx_check_double_final OR NOT __cxx_sizeof_double_final EQUAL "8" )
    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof double [${__cxx_sizeof_double_final}] -- double must be 64 bits exactly" )
endif()

check_type_size( long ODC_SIZEOF_LONG )
check_type_size( double ODC_SIZEOF_DOUBLE )

if( NOT ODC_SIZEOF_LONG EQUAL "8" )
    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof long [${ODC_SIZEOF_LONG}] -- long must be 64 bits exactly" )
elseif( NOT ODC_SIZEOF_LONG EQUAL "8" )
    message( FATAL_ERROR "operating system ${CMAKE_SYSTEM} (${EC_OS_BITS} bits) and sizeof double [${ODC_SIZEOF_LONG}] -- double must be 64 bits exactly" )
endif()

########################################################################################################################
### dependencies and options

ecbuild_find_package( NAME eckit VERSION 1.4 REQUIRED )

ecbuild_add_option( FEATURE FORTRAN
                    DESCRIPTION "whether or not to build the Fortran interface"
                    DEFAULT OFF )

if( HAVE_FORTRAN )
    ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )
endif()

########################################################################################################################
# contents

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

add_subdirectory( src )
add_subdirectory( regressions )
add_subdirectory( tests )

############################################################################################
# finalize

ecbuild_pkgconfig( NAME ${PROJECT_NAME}
                   DESCRIPTION "ECMWF encoding and decoding of observational data in ODB2 format"
                   URL "https://software.ecmwf.int/wiki/display/ODC"
                   LIBRARIES odccore )

ecbuild_install_project( NAME odc )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
## check if all sources are used
ecbuild_find_project_files()

### config header

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/odc )

configure_file( odc_config.h.in odc_config.h )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/odc_config.h DESTINATION ${INSTALL_INCLUDE_DIR}/odc )

### libs

add_subdirectory( odc )
add_subdirectory( odc/tools )

### fortran bindings -- OFF for the moment due to errors with gfortran 6.3 / 7.3
add_subdirectory( fortran )

=== tests/tools/CMakeLists.txt ===
list( APPEND tools_tests_scripts
    test_odb_exit_codes.sh
    test_odb_header.sh
    test_odb_split.sh
    test_odb_sql_split.sh
    test_odb_sql_bitfields.sh
    test_odb_sql_variables.sh
    test_odb_sql_like.sh
    test_odb_sql_format.sh
    test_odb_import.sh )


foreach( _script ${tools_tests_scripts} )
    ecbuild_add_test(
        TARGET odc_${_script}
        TYPE script
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${_script}
        ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
        TEST_DEPENDS odc_get_test_data
    )
endforeach()

# Add a custom target to make these files visible in qtcreator

add_custom_target(
    test_tools_file_visibility
    SOURCES ${tools_tests_scripts}
)

=== debian/changelog ===
odc (1.6.0-1build1) questing; urgency=medium

  * No-change rebuild for gfortran 15.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Sep 2025 14:26:40 +0200

odc (1.6.0-1) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 09 Feb 2025 10:26:01 +0000

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: odc
 Section: utils
 Priority: optional
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (=13),
  dh-fortran-mod (>= 0.31),
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-3),
  libeckit-dev (>= 1.4.6-1~),
  patchelf
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/ecmwf/odc
-Vcs-Browser: https://salsa.debian.org:/science-team/odc.git
-Vcs-Git: https://salsa.debian.org:/science-team/odc.git -b debian/latest
+Vcs-Browser: https://salsa.debian.org/science-team/odc.git
+Vcs-Git: https://salsa.debian.org/science-team/odc.git -b debian/latest
 
 Package: libodc-0d
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/debhelper/dh-fortran/fortran-support.mk

export FC_DEFAULT

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

DO_TEST:=true

# The magic debhelper  rule
%:
	dh $@ --buildsystem=ecbuild --with fortran_mod

BUILD_FLAGS:= -DENABLE_FORTRAN=ON \
			-DENABLE_RPATHS=OFF \

override_dh_auto_configure:
	dh_auto_configure -- \
		      ${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=$(FC_DEFAULT)

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true

override_dh_dwz:
	@echo bypass dwz that causes build failures due to patchelf changes

override_dh_auto_install:
	dh_auto_install 
	mv $(TMPDIR)/$(LIBDIR)/libfodc.so.0d $(TMPDIR)/$(LIBDIR)/libfodc-$(FC_DEFAULT).so.0d
	rm $(TMPDIR)/$(LIBDIR)/libfodc.so
	patchelf  --set-soname libfodc-$(FC_DEFAULT).so.0d $(TMPDIR)/$(LIBDIR)/libfodc-$(FC_DEFAULT).so.0d
	#patchelf  --remove-rpath $(TMPDIR)/$(LIBDIR)/libt-$(FC_DEFAULT).so.0d
	dh_link -p libodc-dev $(LIBDIR)/libfodc-$(FC_DEFAULT).so.0d $(LIBDIR)/libfodc-$(FC_DEFAULT).so
	# Fixup cmake files
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets.cmake
	sed -i -e 's%/include/odc%/usr/include/${DEB_HOST_MULTIARCH}/odc%g' $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets.cmake
	sed -i -e 's%libfodc.so%libfodc-${FC_DEFAULT}.so%g'   $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets-release.cmake

## odc 1.6.1

=== debian/changelog ===
odc (1.6.1-2) unstable; urgency=medium

  * Push to unstable
  * B-D on eckit >= 1.31 . Closes: #1103637

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Aug 2025 08:37:50 +0100

odc (1.6.1-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 21 May 2025 17:11:31 +0100

odc (1.6.0-2) experimental; urgency=medium

  * Depend on eckit >= 1.29.1. Closes: #1103223
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 15 Apr 2025 11:44:39 +0100

=== debian/watch ===
version=3
opts="uversionmangle=s/-rc/~rc/, filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/" \
  https://github.com/ecmwf/odc/tags .*/v?(\d\d?\d?\..+).tar\.gz

## odc 1.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,7 +70,7 @@
 ########################################################################################################################
 ### dependencies and options
 
-ecbuild_find_package( NAME eckit VERSION 1.4 REQUIRED )
+ecbuild_find_package( NAME eckit VERSION 1.29 REQUIRED )
 
 ecbuild_add_option( FEATURE FORTRAN
                     DESCRIPTION "whether or not to build the Fortran interface"

=== docs/Makefile ===
#!/usr/bin/env make -f

# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -W --keep-going  # turn warnings into errors, run to completion
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
sphinx
sphinx-rtd-theme
sphinx-copybutton
sphinx-tabs
breathe
six
sphinx-fortran

=== src/fortran/CMakeLists.txt ===

ecbuild_add_library(TARGET		odc_fortran

                    CONDITION   HAVE_FORTRAN

                    SOURCES
                                # Legacy:

                                odc_c_binding.f90

                    PUBLIC_LIBS odccore

                    PUBLIC_INCLUDES $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
                                    $<INSTALL_INTERFACE:module/odc>
)

set( test_environment_fortran
     TEST_DHSHOME=${PROJECT_SOURCE_DIR}/tests/dhshome/
)

if( HAVE_FORTRAN )

    list( APPEND fortran_tests

        # Legacy API examples
        legacy_fortran_api_examples
        legacy_test_fortran_api_open_non_existing_file
    )

    foreach( _test ${fortran_tests} )
        ecbuild_add_test( TARGET     odc_${_test}
                          CONDITION  HAVE_FORTRAN
                          SOURCES    ${_test}.f90
                          LIBS       odc_fortran 
                          ENVIRONMENT  ${test_environment_fortran}

                          LABELS     odc odc_fortran

                          TEST_DEPENDS odc_get_test_data
                                       odc_get_mars_client_test_data_mo
                                       odc_get_mars_client_test_data_ec

                          LINKER_LANGUAGE Fortran )
    endforeach()

# Legacy Fortran bindings:
    install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/odc_c_binding.mod
             DESTINATION module/odc
             COMPONENT modules )
endif()

=== src/odc/CMakeLists.txt ===
configure_file( ODBAPIVersionSHA1.cc.in ODBAPIVersionSHA1.cc @ONLY )

configure_file( odc_config.f90.in odc_config.f90 )


list( APPEND odclib_src_files

${CMAKE_CURRENT_BINARY_DIR}/ODBAPIVersionSHA1.cc

api/odc.h
api/odc.cc
api/Odb.h
api/Odb.cc
api/ColumnType.h
api/ColumnInfo.h
api/StridedData.h

pyodbapi.h
StringTool.cc
StringTool.h
CommandLineParser.cc
CommandLineParser.h
Comparator.cc
Comparator.h
ConstantSetter.cc
ConstantSetter.h
DispatchingWriter.cc
DispatchingWriter.h
MDI.cc
MDI.h
IteratorProxy.h
LibOdc.cc
LibOdc.h
MDSetter.cc
MDSetter.h
MDUpdatingIterator.cc
MDUpdatingIterator.h
ODAHandle.cc
ODAHandle.h
ODATranslator.h
ODAUpdatingIterator.cc
ODAUpdatingIterator.h
ODBAPISettings.cc
ODBAPISettings.h
ODBAPIVersion.cc
ODBAPIVersion.h
ODBApplication.cc
ODBApplication.h
Select.cc
Select.h
Reader.cc
Reader.h
ReaderIterator.cc
ReaderIterator.h
SelectIterator.cc
SelectIterator.h
TemplateParameters.cc
TemplateParameters.h
Writer.cc
Writer.h
WriterBufferingIterator.cc
WriterBufferingIterator.h
WriterDispatchingIterator.cc
WriterDispatchingIterator.h
odccapi.cc
odccapi.h
RowsCounter.h
RowsCounter.cc
Block.h
Block.cc
Indexer.h
Indexer.cc
RequestUtils.h
RequestUtils.cc
ODBTarget.cc
ODBTarget.h

core/Column.cc
core/Column.h
core/DataStream.h
core/DecodeTarget.cc
core/DecodeTarget.h
core/Encoder.cc
core/Encoder.h
core/Exceptions.cc
core/Exceptions.h
core/Header.cc
core/Header.h
core/MetaData.cc
core/MetaData.h
core/Span.cc
core/Span.h
core/Table.cc
core/Table.h
core/TablesReader.cc
core/TablesReader.h
core/ThreadSharedDataHandle.cc
core/ThreadSharedDataHandle.h
core/Codec.cc
core/Codec.h
core/CodecFactory.h
core/CodecFactory.cc

codec/Constant.cc
codec/Constant.h
codec/Integer.cc
codec/Integer.h
codec/IntegerMissing.cc
codec/IntegerMissing.h
codec/String.cc
codec/String.h
codec/Real.cc
codec/Real.h
codec/CodecOptimizer.cc
codec/CodecOptimizer.h

csv/TextReader.cc
csv/TextReader.h
csv/TextReaderIterator.cc
csv/TextReaderIterator.h

sql/SQLOutputConfig.cc
sql/SQLOutputConfig.h
sql/SQLSelectOutput.cc
sql/SQLSelectOutput.h
sql/ODAOutput.cc
sql/ODAOutput.h
sql/TODATable.cc
sql/TODATable.h
sql/TODATableIterator.cc
sql/TODATableIterator.h
sql/Types.cc
sql/Types.h

utility/Tracer.cc
utility/Tracer.h

#iterator-api/BaseReader.cc
#iterator-api/BaseReader.h
)

# templates

list( APPEND odclib_templates
ConstantSetter.cc
ODAUpdatingIterator.cc
WriterDispatchingIterator.cc
MDUpdatingIterator.cc
)

# define odc library

ecbuild_add_library( TARGET odccore
                     INSTALL_HEADERS
                        LISTED
                     HEADER_DESTINATION
                        ${INSTALL_INCLUDE_DIR}/odc
                     SOURCES
                        ${odclib_src_files}
                     TEMPLATES
                        ${odclib_templates}
                     PUBLIC_INCLUDES
                        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
                        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
                     PUBLIC_LIBS
                        eckit_sql eckit )

ecbuild_add_library(
    TARGET          fodc
    CONDITION       HAVE_FORTRAN
    SOURCES         api/odc.f90
                    ${CMAKE_CURRENT_BINARY_DIR}/odc_config.f90
    PUBLIC_INCLUDES $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/module>
                    $<INSTALL_INTERFACE:module/odc>
    PUBLIC_LIBS     odccore
)

if ( HAVE_FORTRAN AND ECBUILD_INSTALL_FORTRAN_MODULES )
    install( FILES ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}/odc.mod
             DESTINATION module/odc
             COMPONENT modules )
endif()

=== tests/c_api/CMakeLists.txt ===

list( APPEND _capi_odc_tests
    read
    encode
)

foreach( _test ${_capi_odc_tests} )
    ecbuild_add_test(
        TARGET       odc_capi_${_test}
        SOURCES      ${_test}.cc
        ENVIRONMENT  ${test_environment}
        TEST_DEPENDS odc_get_test_data
        LIBS         eckit odccore )
endforeach()

list( APPEND _capi_odc_example_sources
    odc_header
    odc_encode_custom
    odc_encode_row_major
    odc_ls
)

list( APPEND _capi_odc_example_targets
    odc-c-header
    odc-c-encode-custom
    odc-c-encode-row-major
    odc-c-ls
)

list( LENGTH _capi_odc_example_sources _count )
math( EXPR _count "${_count}-1" )

foreach( _i RANGE ${_count} )
    list( GET _capi_odc_example_sources ${_i} _sources )
    list( GET _capi_odc_example_targets ${_i} _target )

    ecbuild_add_executable( TARGET     ${_target}
                            SOURCES    ${_sources}.c
                            LIBS       odccore
                            NOINSTALL )
endforeach()

list( APPEND _capi_odc_tests_scripts
    usage_examples.sh
)

foreach( _script ${_capi_odc_tests_scripts} )
    ecbuild_add_test(
        TARGET odc_capi_${_script}
        TYPE script
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${_script}
        ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
    )
endforeach()

=== tests/core/CMakeLists.txt ===

list( APPEND core_data_files
    odb_533_1.odb
    odb_533_2.odb
)

ecbuild_get_test_multidata( TARGET odc_get_core_data
                            NAMES ${core_data_files}
                            NOCHECK )


list( APPEND _core_odc_tests
    test_encode_odb
    test_decode_odb
    test_codecs_write
    test_codecs_read
    test_codecs_end_to_end
    test_codecs_end_to_end2
    test_reencode_string_table
    test_concatenated_odbs
    test_minmax
    test_metadata

    test_select_iterator
    test_text_reader
    test_table_iterator
    test_initial_missing
)

foreach( _test ${_core_odc_tests} )
    ecbuild_add_test(
        TARGET       odc_${_test}
        SOURCES      ${_test}.cc ../TemporaryFiles.h
        TEST_DEPENDS odc_get_test_data odc_get_core_data
        ENVIRONMENT  ${test_environment}
        LIBS         eckit odccore )
endforeach()

=== tests/f_api/CMakeLists.txt ===
--- 
+++ 
@@ -12,6 +12,7 @@
         ENVIRONMENT  ${test_environment}
         TEST_DEPENDS odc_get_test_data
         CONDITION    HAVE_FORTRAN
+        LINKER_LANGUAGE Fortran
         LIBS         fodc )
 endforeach()
 
@@ -40,6 +41,7 @@
                             SOURCES    ${_sources}.f90
                             LIBS       fodc
                             CONDITION  HAVE_FORTRAN
+                            LINKER_LANGUAGE Fortran
                             NOINSTALL )
 endforeach()

=== tests/sql/CMakeLists.txt ===

list( APPEND _sql_odc_tests
    test_functions
    test_text_reader_select
    test_oda_output
)

foreach( _test ${_sql_odc_tests} )
    ecbuild_add_test(
        TARGET       odc_${_test}
        SOURCES      ${_test}.cc ../TemporaryFiles.h
        ENVIRONMENT  ${test_environment}
        TEST_DEPENDS odc_get_test_data
        LIBS         eckit odccore )
endforeach()



# TODO: Pure tests for the pure-sql stuff. The functions clearly invoke odc-specific behaviour

=== src/odc/tools/CMakeLists.txt ===
list( APPEND odctools_src_files
TestCase.h
TestCase.cc
TestRunner.cc
TestRunner.h
TestRunnerApplication.cc
TestRunnerApplication.h
TestRunnerApplication.cfg
CompactTool.cc
CompactTool.h
CompareTool.cc
CompareTool.h
CountTool.cc
CountTool.h
IndexTool.cc
IndexTool.h
FixedSizeRowTool.cc
FixedSizeRowTool.h
ImportTool.cc
ImportTool.h
LSTool.cc
LSTool.h
MDSetTool.cc
MDSetTool.h
MergeTool.cc
MergeTool.h
#ODA2RequestTool.cc
#ODA2RequestTool.h
ODAHeaderTool.cc
ODAHeaderTool.h
SQLTool.cc
SQLTool.h
SetTool.cc
SetTool.h
SplitTool.cc
SplitTool.h
Tool.cc
Tool.h
ToolFactory.cc
ToolFactory.h
ToolRunnerApplication.cc
ToolRunnerApplication.h
XYVTool.cc
XYVTool.h
)

list( APPEND odctest_src_files
Examples.cc
CAPIExamples.cc
UnitTests.cc
TestAggregateFunctions.cc
TestAggregateFunctions2.cc
TestAggregateFunctions3.cc
TestAtTableInTheOutput.cc
TestBitfields.cc
TestCommandLineParsing.cc
TestDispatchingWriter.cc
TestDistinct.cc
TestFunctionDateAndTime.cc
TestFunctionTdiff.cc
TestFunctionThin.cc
TestFunctionTypeConversion.cc
TestFunctionsForAngleConversion.cc
TestFunctionsForTemperatureConversion.cc
TestInt16_MissingCodec.cc
TestIntegerValues.cc
TestMetaData.cc
TestMetaDataReader.ksh
TestMissingValue.cc
TestOdaCAPI.cc
TestOdaCAPI.h
TestOrderBy.cc
TestSelectDataHandle.cc
TestSelectStarAt.cc
TestSelectTwoFiles.cc
TestSetvbuffer.cc
TestStar.cc
MockReader.h
MockReader.cc
)

ecbuild_add_library( TARGET     odctools
                     INSTALL_HEADERS LISTED
                     HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/odc/tools
                     SOURCES    ${odctools_src_files}
                     TEMPLATES  ${odctools_templates}
                     PUBLIC_LIBS odccore )

ecbuild_add_library( TARGET     odctest
                     #INSTALL_HEADERS LISTED
                     #HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/odc/tools
                     SOURCES    ${odctest_src_files}
                     TEMPLATES  ${odctest_templates}
                     PUBLIC_LIBS  odccore odctools )

## TODO: Re-enable odctest

ecbuild_add_executable( TARGET    odc
                        SOURCES   odc.cc
                        LIBS      odccore odctools odctest )

=== src/odc/tools/Makefile ===
all:
	m

=== debian/changelog ===
odc (1.6.2-2) unstable; urgency=medium

  * Change cmake script to use -gnu version of libfodc

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 19 Oct 2025 10:31:45 +0100

odc (1.6.2-1) unstable; urgency=medium

  * New upstream release
  * Move d/watch to version 4
  * Remove old FSF address from d/copyright
  * cross.patch: Drop checks that break cross-building. Thanks to
    Helmut Grohe. Closes: #1063339
  * Use dh_fortran_lib for Fortran libraries

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Oct 2025 08:40:35 +0100

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
  dh-fortran-mod (>= 0.31),
  architecture-is-64-bit,
  ecbuild (>= 3.3.0-3),
- libeckit-dev (>= 1.4.6-1~),
+ libeckit-dev (>= 1.31.1-1~),
  patchelf
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ecmwf/odc
 Vcs-Browser: https://salsa.debian.org/science-team/odc.git
 Vcs-Git: https://salsa.debian.org/science-team/odc.git -b debian/latest

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/debhelper/dh-fortran/fortran-support.mk

export FC_DEFAULT

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

DO_TEST:=true

# The magic debhelper  rule
%:
	dh $@ --buildsystem=ecbuild --with fortran

BUILD_FLAGS:= -DENABLE_FORTRAN=ON \
			-DENABLE_RPATHS=OFF \

override_dh_auto_configure:
	dh_auto_configure -- \
		      ${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=$(FC_DEFAULT)

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true

override_dh_dwz:
	@echo bypass dwz that causes build failures due to patchelf changes

override_dh_auto_install:
	dh_auto_install 
	# Fixup cmake files
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets.cmake
	sed -i -e 's%/include/odc%/usr/include/${DEB_HOST_MULTIARCH}/odc%g' $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets.cmake
	sed -i -e 's%libfodc.so%libfodc-gnu.so%g'   $(TMPDIR)/$(LIBDIR)/cmake/odc/odc-targets-release.cmake

=== debian/watch ===
version=4
https://github.com/ecmwf/odc/tags .*/v?(\d.*)@ARCHIVE_EXT@

## odc 1.6.3

=== debian/changelog ===
odc (1.6.3-1) unstable; urgency=medium

  * New upstream release
  * Avoid leading / in paths
  * http->https in d/copyright
  * Cleanup d/control via cme
  * Add headers to patches

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 23 Feb 2026 05:53:28 +0000

odc (1.6.2-3) unstable; urgency=medium

  * Move B-D from dh-fortran-mod to dh-fortran
  * Standards-Version: 4.7.3
  * Drop .git from vcs-browser
  * Drop priority: optional
  * Add d/salsa-ci.yml
  * Add gbp.conf; use pristine-tar

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Feb 2026 08:46:27 +0000

=== debian/control ===
Source: odc
Standards-Version: 4.7.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Alastair McKinstry <mckinstry@debian.org>,
Section: utils
Build-Depends:
 debhelper-compat (=13),
 dh-fortran,
 architecture-is-64-bit,
 ecbuild,
 libeckit-dev (>= 1.31.1-1~),
 patchelf,
Vcs-Browser: https://salsa.debian.org/science-team/odc
Vcs-Git: https://salsa.debian.org/science-team/odc.git -b debian/latest
Homepage: https://github.com/ecmwf/odc

Package: libodc-0d
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Observational Database Access library for ECMWF
 ODC is software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++ and Fortran.

Package: odc
Architecture: any
Multi-Arch: foreign
Depends:
 libodc-0d ( = ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 libodc-dev (= ${binary:Version}),
Description: Tools for the Observational Data Processing (ODB)
 ODC is software developed at ECMWF for encoding and processing o
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++ and Fortran.
 .
 This package provides tools for ODB handling.

Package: libodc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libodc-0d (= ${binary:Version}),
 odc (= ${binary:Version}),
 ${misc:Depends},
 mpi-default-dev,
 libeckit-dev,
 ${fortran:Depends},
Recommends:
 pkgconf,
 ${fortran:Recommends},
Conflicts:
 libodb-dev,
Description: Observational Data processing for meteorology
 ODC is a software developed at ECMWF for encoding and processing of
 observational data. It includes a SQL filtering and statistics engine, 
 command line tools and APIs for C/C++, Fortran and Python.
 .
 This package provides shared libraries and headers.
